const char uri_lua[] =
"-- uri.lua (internal file)\n"
"\n"
"local ffi = require('ffi')\n"
"\n"
"ffi.cdef[[\n"
"struct uri {\n"
"    const char *scheme;\n"
"    size_t scheme_len;\n"
"    const char *login;\n"
"    size_t login_len;\n"
"    const char *password;\n"
"    size_t password_len;\n"
"    const char *host;\n"
"    size_t host_len;\n"
"    const char *service;\n"
"    size_t service_len;\n"
"    const char *path;\n"
"    size_t path_len;\n"
"    const char *query;\n"
"    size_t query_len;\n"
"    const char *fragment;\n"
"    size_t fragment_len;\n"
"    int host_hint;\n"
"};\n"
"\n"
"int\n"
"uri_parse(struct uri *uri, const char *str);\n"
"]]\n"
"\n"
"local builtin = ffi.C;\n"
"\n"
"local uribuf = ffi.new('struct uri')\n"
"\n"
"local function parse(str)\n"
"    if str == nil then\n"
"        error(\"Usage: uri.parse(string)\")\n"
"    end\n"
"    if builtin.uri_parse(uribuf, str) ~= 0 then\n"
"        return nil\n"
"    end\n"
"    local result = {}\n"
"    for _, k in ipairs({ 'scheme', 'login', 'password', 'host', 'service',\n"
"        'path', 'query', 'fragment'}) do\n"
"        if uribuf[k] ~= nil then\n"
"            result[k] = ffi.string(uribuf[k], uribuf[k..'_len'])\n"
"        end\n"
"    end\n"
"    if uribuf.host_hint == 1 then\n"
"        result.ipv4 = result.host\n"
"    elseif uribuf.host_hint == 2 then\n"
"        result.ipv6 = result.host\n"
"    elseif uribuf.host_hint == 3 then\n"
"        result.unix = result.service\n"
"    end\n"
"    return result\n"
"end\n"
"\n"
"return {\n"
"    parse = parse;\n"
"};\n"
""
;
